package com.example.onomatopoeiaback.controller;


import com.example.onomatopoeiaback.domain.employee.Employee;
import com.example.onomatopoeiaback.domain.employee.EmployeeDTO;
import com.example.onomatopoeiaback.domain.visit.Visit;
import com.example.onomatopoeiaback.domain.visit.VisitDTO;
import com.example.onomatopoeiaback.service.EmployeeService;
import com.example.onomatopoeiaback.service.VisitService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/api")
public class EmployeeController {
    private final VisitService visitService;
    private final EmployeeService employeeService;

    public EmployeeController(EmployeeService employeeService, VisitService visitService) {
        this.employeeService = employeeService;
        this.visitService = visitService;
    }

    @GetMapping("/hello")
    public String hello(@RequestParam(value = "name", defaultValue = "World") String name) {
        return String.format("Hello %s!", name);
    }

    @PostMapping("/create")
    public ResponseEntity<Employee> createEmployee(@RequestBody EmployeeDTO employeeDTO) {
        return ResponseEntity.ok(employeeService.createEmployee(employeeDTO));
    }

    @GetMapping("/{username}/info")
    public ResponseEntity<Employee> info(@PathVariable String username) {
        return employeeService.info(username);
    }

    @GetMapping("/{username}/auth")
    public ResponseEntity<Visit> auth(@PathVariable String username) {
        return new ResponseEntity<>(null, employeeService.auth(username));
    }

    @PatchMapping("/{username}/open")
        public ResponseEntity<Visit> open(@PathVariable String username, VisitDTO visitDTO) {
        visitService.open(username, visitDTO.getValue());
        return new ResponseEntity<>(HttpStatus.OK);
    }
}
